require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SYS_BYTEORDER_H)) {
    eval 'sub _SYS_BYTEORDER_H () {1;}' unless defined(&_SYS_BYTEORDER_H);
    require 'sys/isa_defs.ph';
    require 'sys/int_types.ph';
    if(defined( &__GNUC__)  && defined( &_ASM_INLINES)  && (defined( &__i386) || defined( &__amd64))) {
	require 'asm/byteorder.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if(defined( &_BIG_ENDIAN)  && !defined( &ntohl)  && !defined( &__lint)) {
	eval 'sub ntohl {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&ntohl);
	eval 'sub ntohs {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&ntohs);
	eval 'sub htonl {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&htonl);
	eval 'sub htons {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&htons);
    }
 elsif(!defined( &ntohl) ) {
	unless(defined(&_IN_PORT_T)) {
	    eval 'sub _IN_PORT_T () {1;}' unless defined(&_IN_PORT_T);
	}
	unless(defined(&_IN_ADDR_T)) {
	    eval 'sub _IN_ADDR_T () {1;}' unless defined(&_IN_ADDR_T);
	}
	if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__) || defined( &_XPG5)) {
	} else {
	}
    }
    if(!defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub BSWAP_8 {
	    my($x) = @_;
    	    eval q((($x) & 0xff));
	}' unless defined(&BSWAP_8);
	eval 'sub BSWAP_16 {
	    my($x) = @_;
    	    eval q((( &BSWAP_8($x) << 8) |  &BSWAP_8(($x) >> 8)));
	}' unless defined(&BSWAP_16);
	eval 'sub BSWAP_32 {
	    my($x) = @_;
    	    eval q((( &BSWAP_16($x) << 16) |  &BSWAP_16(($x) >> 16)));
	}' unless defined(&BSWAP_32);
	eval 'sub BSWAP_64 {
	    my($x) = @_;
    	    eval q((( &BSWAP_32($x) << 32) |  &BSWAP_32(($x) >> 32)));
	}' unless defined(&BSWAP_64);
	eval 'sub BMASK_8 {
	    my($x) = @_;
    	    eval q((($x) & 0xff));
	}' unless defined(&BMASK_8);
	eval 'sub BMASK_16 {
	    my($x) = @_;
    	    eval q((($x) & 0xffff));
	}' unless defined(&BMASK_16);
	eval 'sub BMASK_32 {
	    my($x) = @_;
    	    eval q((($x) & 0xffffffff));
	}' unless defined(&BMASK_32);
	eval 'sub BMASK_64 {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&BMASK_64);
	if(defined(&_BIG_ENDIAN)) {
	    eval 'sub BE_8 {
	        my($x) = @_;
    		eval q( &BMASK_8($x));
	    }' unless defined(&BE_8);
	    eval 'sub BE_16 {
	        my($x) = @_;
    		eval q( &BMASK_16($x));
	    }' unless defined(&BE_16);
	    eval 'sub BE_32 {
	        my($x) = @_;
    		eval q( &BMASK_32($x));
	    }' unless defined(&BE_32);
	    eval 'sub BE_64 {
	        my($x) = @_;
    		eval q( &BMASK_64($x));
	    }' unless defined(&BE_64);
	    eval 'sub LE_8 {
	        my($x) = @_;
    		eval q( &BSWAP_8($x));
	    }' unless defined(&LE_8);
	    eval 'sub LE_16 {
	        my($x) = @_;
    		eval q( &BSWAP_16($x));
	    }' unless defined(&LE_16);
	    eval 'sub LE_32 {
	        my($x) = @_;
    		eval q( &BSWAP_32($x));
	    }' unless defined(&LE_32);
	    eval 'sub LE_64 {
	        my($x) = @_;
    		eval q( &BSWAP_64($x));
	    }' unless defined(&LE_64);
	} else {
	    eval 'sub LE_8 {
	        my($x) = @_;
    		eval q( &BMASK_8($x));
	    }' unless defined(&LE_8);
	    eval 'sub LE_16 {
	        my($x) = @_;
    		eval q( &BMASK_16($x));
	    }' unless defined(&LE_16);
	    eval 'sub LE_32 {
	        my($x) = @_;
    		eval q( &BMASK_32($x));
	    }' unless defined(&LE_32);
	    eval 'sub LE_64 {
	        my($x) = @_;
    		eval q( &BMASK_64($x));
	    }' unless defined(&LE_64);
	    eval 'sub BE_8 {
	        my($x) = @_;
    		eval q( &BSWAP_8($x));
	    }' unless defined(&BE_8);
	    eval 'sub BE_16 {
	        my($x) = @_;
    		eval q( &BSWAP_16($x));
	    }' unless defined(&BE_16);
	    eval 'sub BE_32 {
	        my($x) = @_;
    		eval q( &BSWAP_32($x));
	    }' unless defined(&BE_32);
	    eval 'sub BE_64 {
	        my($x) = @_;
    		eval q( &BSWAP_64($x));
	    }' unless defined(&BE_64);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
